#!/usr/bin/env python3
#
# @package      hubzero-submit-monitors
# @file         monitorJobSiteR.py
# @copyright    Copyright (c) 2026-2026 The Regents of the University of California.
# @license      http://opensource.org/licenses/MIT MIT
#
# Copyright (c) 2026-2026 The Regents of the University of California.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# HUBzero is a registered trademark of The Regents of the University of California.
#
# ----------------------------------------------------------------------
#  monitorJobSiteR.py
#
#  script which queries monitorJob.py for job sites
#
import os
import sys
import time
import re
import logging

from hubzero.submit.ApplicationUtilities import ApplicationUtilities as ApplicationUtilities
from hubzero.submit.DaemonsInfo          import DaemonsInfo
from hubzero.submit.RemoteJobMonitor     import RemoteJobMonitor

SUBMITUTILITYLOGLEVEL = "ERROR"

DAEMONSDIRECTORY         = os.path.join(os.sep,"etc","submit")
DAEMONSCONFIGURATIONFILE = 'daemons.conf'

def natsort(listValues):
   def tryInt(stringValue):
      try:
         return int(stringValue)
      except:
         return stringValue.lower()

   def alphanumKey(stringValue):
      """ Turn a string into a list of string and number chunks.
          "z23a" -> ["z", 23, "a"]
      """
      return [ tryInt(chunk) for chunk in re.split('([0-9]+)', stringValue) ]

   """ Sort the given list in the way that humans expect.
   """
   listValues.sort(key=alphanumKey)


def monitorJobSiteR(listenURI):
   """Report jobsites"""
   if   len(sys.argv) == 2:
      jobSiteState = sys.argv[1]
   else:
      jobSiteState = 'active'

   remoteJobMonitor = RemoteJobMonitor(listenURI)

   report = remoteJobMonitor.queryRemoteJobSitesWithState(jobSiteState)

   headerPrinted = False
   if len(report['jobSites']) > 0:
      jobSiteNames = list(report['jobSites'].keys())
      natsort(jobSiteNames)
      print("%-30s Time Updated" % (jobSiteState + " Job Site"))
      print(50*"-")
      headerPrinted = True

      for jobSiteName in jobSiteNames:
         timeUpdated = report['jobSites'][jobSiteName]
         if timeUpdated > 0:
            print("%-30s %s" % (jobSiteName,time.ctime(timeUpdated)))
         else:
            print("%-30s" % (jobSiteName))

   if not headerPrinted:
      print("No %s job sites are currently being processed" % (jobSiteState))
      headerPrinted = True


if __name__ == '__main__':
   submitUtilityLogLevel    = os.getenv("SUBMITUTILITYLOGLEVEL",SUBMITUTILITYLOGLEVEL)
   daemonsDirectory         = os.getenv("DAEMONSDIRECTORY",DAEMONSDIRECTORY)
   daemonsConfigurationFile = os.getenv("DAEMONSCONFIGURATIONFILE",DAEMONSCONFIGURATIONFILE)

   applicationUtilities = ApplicationUtilities(SUBMITUTILITYLOGLEVEL)
   applicationUtilities.openStreamLogger(sys.stderr,
                                         submitUtilityLogLevel)

   configFilePath = os.path.join(daemonsDirectory,daemonsConfigurationFile)
   daemonsInfo    = DaemonsInfo(configFilePath)
   listenURI      = daemonsInfo.getDaemonListenURI('jobMonitor','tcp')

   monitorJobSiteR(listenURI)


